package cheddar.aadl;

import org.osate.aadl2.EnumerationLiteral;
import org.osate.aadl2.NamedElement;
import org.osate.aadl2.Property;
import org.osate.xtext.aadl2.properties.util.GetProperties;
import org.osate.xtext.aadl2.properties.util.PropertyUtils;

public class AADLv3_Util {

	public static final String _NAME = "AADLV3";

	/* Processor properties */
	public static final String SYSTEM_SOC_TYPE = "System_Soc_Type";

	public static Soc_Type getSystemSocType(final NamedElement ne) {
		Soc_Type val = Soc_Type.Not_A_SoC_Unit;
		try {
			Property sr = GetProperties.lookupPropertyDefinition(ne, _NAME, SYSTEM_SOC_TYPE);
			EnumerationLiteral s = PropertyUtils.getEnumLiteral(ne, sr);
			String rrr = s.getName();
			rrr = rrr.toLowerCase();
			if (s != null) {
				val = Soc_Type.fromString(rrr);
			}
		} catch (Exception e) {
		}
		return val;
	}

}
