package cheddar.aadl;

public class Cheddar_Parameters_Properties {

	/*
	 * Here is the list of AADL properties for Cheddar.
	 * Some of those properties are specific to scheduling features of Cheddar.
	 * Others are now part of the AADL standard, and are kept for legacy reasons.
	 */

	public static final String _NAME = "Cheddar_Parameters_Properties";

	/* Parameters to set Cheddar environment */
	public static final String CHEDDAR_WORKING_FOLDER = "Cheddar_Working_Folder";
	public static final String CHEDDAR_INSTALL_FOLDER = "Cheddar_Install_Folder";

	/* Compute WCRT with simulation or feasibility tests ? */
	public static final String RESPONSE_TIME_FROM_SCHEDULING_SIMULATION = "Response_Time_From_Scheduling_Simulation";
	public static final String RESPONSE_TIME_FROM_FEASIBILITY_TEST = "Response_Time_From_Feasibility_Test";

	/* Parameters to compute WCRT with feasibility tests */
	public static final String RESPONSE_TIME_WITH_MEMORY_INTERFERENCE = "Response_Time_With_Memory_Interference";
	public static final String RESPONSE_TIME_WITH_CACHE_INTERFERENCE = "Response_Time_With_Cache_Interference";

	/* Parameters to compute WCRT with scheduling simulations */
	public static final String SCHEDULING_FEASIBILITY_INTERVAL = "Scheduling_Feasibility_Interval";
	public static final String SCHEDULING_WITH_OFFSETS = "Scheduling_With_Offsets";
	public static final String SCHEDULING_WITH_RESOURCES = "Scheduling_With_Resources";
	public static final String SCHEDULING_WITH_JITTERS = "Scheduling_With_Jitters";
	public static final String SCHEDULING_WITH_CRPD = "Scheduling_With_CRPD";
	public static final String SCHEDULING_WITH_PRECEDENCIES = "Scheduling_With_Precendencies";

}

