package cheddar.aadl;

import org.osate.aadl2.NamedElement;
import org.osate.aadl2.Property;
import org.osate.xtext.aadl2.properties.util.GetProperties;
import org.osate.xtext.aadl2.properties.util.PropertyUtils;

public class Cheddar_Parameters_Properties_Util {

	public static long getSchedulingFeasibilityInterval(final NamedElement ne) {
		Property val = GetProperties.lookupPropertyDefinition(ne, Cheddar_Parameters_Properties._NAME,
				Cheddar_Parameters_Properties.SCHEDULING_FEASIBILITY_INTERVAL);
		return PropertyUtils.getIntegerValue(ne, val, 0);
	}

	public static String getCheddar_Install_Folder(final NamedElement ne) {
		Property s = GetProperties.lookupPropertyDefinition(ne, Cheddar_Parameters_Properties._NAME,
				Cheddar_Parameters_Properties.CHEDDAR_INSTALL_FOLDER);
		return PropertyUtils.getStringValue(ne, s);
	}

	public static String getCheddar_Working_Folder(final NamedElement ne) {
		Property s = GetProperties.lookupPropertyDefinition(ne, Cheddar_Parameters_Properties._NAME,
				Cheddar_Parameters_Properties.CHEDDAR_WORKING_FOLDER);
		return PropertyUtils.getStringValue(ne, s);
	}

	public static boolean getSchedulingWithPrecendencies(final NamedElement ne) {
		Property val = GetProperties.lookupPropertyDefinition(ne, Cheddar_Parameters_Properties._NAME,
				Cheddar_Parameters_Properties.SCHEDULING_WITH_PRECEDENCIES);
		return PropertyUtils.getBooleanValue(ne, val);
	}

	public static boolean getSchedulingWithResources(final NamedElement ne) {
		Property val = GetProperties.lookupPropertyDefinition(ne, Cheddar_Parameters_Properties._NAME,
				Cheddar_Parameters_Properties.SCHEDULING_WITH_RESOURCES);
		return PropertyUtils.getBooleanValue(ne, val);
	}

	public static boolean getSchedulingWithOffsets(final NamedElement ne) {
		Property val = GetProperties.lookupPropertyDefinition(ne, Cheddar_Parameters_Properties._NAME,
				Cheddar_Parameters_Properties.SCHEDULING_WITH_OFFSETS);
		return PropertyUtils.getBooleanValue(ne, val);
	}

	public static boolean getSchedulingWithCRPD(final NamedElement ne) {
		Property val = GetProperties.lookupPropertyDefinition(ne, Cheddar_Parameters_Properties._NAME,
				Cheddar_Parameters_Properties.SCHEDULING_WITH_CRPD);
		return PropertyUtils.getBooleanValue(ne, val);
	}

	public static boolean getSchedulingWithJitters(final NamedElement ne) {
		Property val = GetProperties.lookupPropertyDefinition(ne, Cheddar_Parameters_Properties._NAME,
				Cheddar_Parameters_Properties.SCHEDULING_WITH_JITTERS);
		return PropertyUtils.getBooleanValue(ne, val);
	}

	public static boolean getResponseTimeFromSchedulingSimulation(final NamedElement ne) {
		Property val = GetProperties.lookupPropertyDefinition(ne, Cheddar_Parameters_Properties._NAME,
				Cheddar_Parameters_Properties.RESPONSE_TIME_FROM_SCHEDULING_SIMULATION);
		return PropertyUtils.getBooleanValue(ne, val);
	}

	public static boolean getResponseTimeFromFeasibilityTest(final NamedElement ne) {
		Property val = GetProperties.lookupPropertyDefinition(ne, Cheddar_Parameters_Properties._NAME,
				Cheddar_Parameters_Properties.RESPONSE_TIME_FROM_FEASIBILITY_TEST);
		return PropertyUtils.getBooleanValue(ne, val);
	}

}
