package cheddar.aadl;

import org.osate.aadl2.EnumerationLiteral;
import org.osate.aadl2.NamedElement;
import org.osate.aadl2.Property;
import org.osate.aadl2.properties.PropertyLookupException;
import org.osate.xtext.aadl2.properties.util.GetProperties;
import org.osate.xtext.aadl2.properties.util.PropertyUtils;

public class Cheddar_Transformation_Properties_Util {


	public static EnumerationLiteral getDebug_Level(final NamedElement ne) {
		try {
			Property val = GetProperties.lookupPropertyDefinition(ne, Cheddar_Transformation_Properties._NAME,
					Cheddar_Transformation_Properties.DEBUG_LEVEL);
			return PropertyUtils.getEnumLiteral(ne, val);
		} catch (final PropertyLookupException e) {
			return null;
		}
	}

	public static boolean getIs_Data_Port_To_Time_Triggered_Dependency(final NamedElement ne) {
		Property val = GetProperties.lookupPropertyDefinition(ne, Cheddar_Transformation_Properties._NAME,
				Cheddar_Transformation_Properties.DATA_PORT_TO_TIME_TRIGGERED_DEPENDENCY);
		return PropertyUtils.getBooleanValue(ne, val);
	}

	public static boolean getIs_Transform_Sporadic_To_Periodic(final NamedElement ne) {
		Property is_preemptive = GetProperties.lookupPropertyDefinition(ne, Cheddar_Transformation_Properties._NAME,
				Cheddar_Transformation_Properties.TRANSFORM_SPORADIC_TO_PERIODIC);
		return PropertyUtils.getBooleanValue(ne, is_preemptive);
	}

	public static boolean getIs_Transform_Poisson_To_Periodic(final NamedElement ne) {
		Property is_preemptive = GetProperties.lookupPropertyDefinition(ne, Cheddar_Transformation_Properties._NAME,
				Cheddar_Transformation_Properties.TRANSFORM_POISSON_TO_PERIODIC);
		return PropertyUtils.getBooleanValue(ne, is_preemptive);
	}


	public static EnumerationLiteral getExported_Attribute_Time_Units(final NamedElement ne) {
		try {
			Property val = GetProperties.lookupPropertyDefinition(ne, Cheddar_Transformation_Properties._NAME,
					Cheddar_Transformation_Properties.EXPORTED_ATTRIBUTE_TIME_UNITS);
			return PropertyUtils.getEnumLiteral(ne, val);
		} catch (final PropertyLookupException e) {
			return null;
		}
	}

}
