package cheddar.aadl;

import java.util.ArrayList;

import org.osate.aadl2.instance.ComponentInstance;

import cheddar.adl.Core_Unit;
import cheddar.adl.Generic_Processor;
import cheddar.adl.Migrations_Type;
import cheddar.adl.Mono_Core_Processor;
import cheddar.adl.Multi_Cores_Processor;
import cheddar.adl.Objects_Type;
import cheddar.adl.Processors_Type;
import cheddar.osate2_plugin.Debug;

public class To_Processor {


	static public Generic_Processor Create_MPSoC_Processor_Component(Core_Unit c,
			cheddar.adl.System result,
			Cheddar_Id_Generator id,
			ComponentInstance component,
			ComponentInstance parent_system) {

		Generic_Processor cpu = null;

		// Check if the system already exists and then add the core, otherwise
		// create the multicore
		//
		String name = parent_system.getInstanceObjectPath().toString();
		cpu = result.Search_Processor(name);
		if (cpu==null)
		{
			// Create the instance
			Multi_Cores_Processor mcp = new Multi_Cores_Processor();
			ArrayList<Core_Unit> cores = new ArrayList<Core_Unit>();
			cores.add(c);

		    Migrations_Type mig = Properties_With_Default_Value.getMigrations_Type(parent_system);
		    Processors_Type proc = Properties_With_Default_Value.getProcessors_Type(parent_system);

			mcp.setName(name);
			mcp.setProcessorType(proc);
			mcp.setcheddarXmlId(id.getAndIncrement());
			mcp.setObjectType(Objects_Type.Processor_Object_Type);
			mcp.setCores(cores);
			mcp.setMigrationType(mig);
			Debug.Put("To_Processor/Create_MPSoC_Processor_Component ; add multicores processor " + mcp.getName());
			result.processors.add(mcp);
			cpu=mcp;
		}
		else
		{
			// Look for the instance and add the core
			Multi_Cores_Processor mcp = (Multi_Cores_Processor)cpu;
			ArrayList<Core_Unit> cores = mcp.getCores();
			cores.add(c);
			Debug.Put("To_Processor/Create_MPSoC_Processor_Component ; add a core to an existing multicores processor " + mcp.getName());
		}

		return cpu;
	}




	static public Generic_Processor Create_MonoCore_Processor(cheddar.adl.System result, Cheddar_Id_Generator id,
			Core_Unit core, ComponentInstance component) {

		String name = component.getInstanceObjectPath().toString();

		// A processor, with its core unit
		//
		Mono_Core_Processor mcp = new Mono_Core_Processor();
		mcp.setName(name);
		mcp.setcheddarXmlId(id.getAndIncrement());
		mcp.setObjectType(Objects_Type.Processor_Object_Type);
		mcp.setCore(core);
		mcp.setMigrationType(Migrations_Type.No_Migration_Type);
		mcp.setProcessorType(Processors_Type.Monocore_type);

		Debug.Put("To_Processor/Create_MonoCore_Processor ; add monocore processor " + mcp.getName());

		result.processors.add(mcp);
		return mcp;
	}
}
